
#include <assembleit2_64.au3>


#cs _numberofpixel
    use32

    mov edi,[esp+4]                        ;pointer pixel
    mov ecx,[esp+8]                        ;number pixel BxH
    dec ecx
    mov ebx,[esp+12]                       ;color pixel

	xor eax,eax                            ;eax=0 ;counter pixel with color

    _next:                                 ;label: for ecx=numberpixel to 0
    cmp ebx,[edi+ecx*4]                    ;is dword=color ?  (4 Bytes per pixel)
    jne _no                                ;no, next Pixel
    inc eax                                ;yes, one more found
    _no:                                   ;Label: no pixel with color was found
    loop _next                             ;ecx=ecx-1 ;jump if not zero (ecx=0) to label

    ret                                    ;return, returns eax
#ce _numberofpixel



;binary aus assemblercode erstellen (für dllcalladdress benötigt, nur beispiel)
$binarycode = _AssembleIt2("retbinary", "_numberofpixel") ;gibt nur den code zurück
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $binarycode = ' & $binarycode & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

;nur für dllcalladdress() benötigt, den binarycode braucht man nur ein mal erstellen
Global $tCodeBuffer = DllStructCreate("byte[" & StringLen($binarycode) / 2 - 1 & "]") ;reserve Memory for opcodes
DllStructSetData($tCodeBuffer, 1, $binarycode) ;"0x8B7C24048B542408B900000000BB00000000B8FF000000C1E00809D0C1E00809D8C1E00809C8890783C7044381FB0001000075DE4181F90001000075D0C3") ;write opcodes into memory

$height = @DesktopHeight
$width = @DesktopWidth


$col = 0xFFFFFFFF                          ; AARRGGBB

$DC_screen = _WinAPI_GetDC(0)
Global $ptr, $hbmp                         ;pointer auf die pixel, handle bitmap
$DC_bitmap = _CreateNewBmp32($width, $height, $ptr, $hbmp) ;bitmap erstellen

_WinAPI_BitBlt($DC_bitmap, 0, 0, $width, $height, $DC_screen, 0, 0, 0xCC0020) ;$srccopy copy screenpixel into bitmap

;entweder Assembleit benutzen, assembliert code während der Laufzeit JIT
$t = TimerInit()
Local $ret = _AssembleIt2("uint", "_numberofpixel", "ptr", $ptr, "int", $width * $height, "dword", $col)
ConsoleWrite("_AssembleIt2()       Number Pixel with color " & Hex($col) & " on the whole screen (" & $width & "x" & $height & ") = " & $ret & "     Time [ms] = " & Int(1000 * TimerDiff($t)) / 1000 & @CRLF) ;### Debug Console

;oder den schnelleren Dllcalladdress
$t = TimerInit()
$ret = DllCallAddress("uint:cdecl", DllStructGetPtr($tCodeBuffer), "ptr", $ptr, "int", $width * $height, "dword", $col)
ConsoleWrite("DllCallAddress()     Number Pixel with color " & Hex($col) & " on the whole screen (" & $width & "x" & $height & ") = " & $ret[0] & "     Time [ms] = " & Int(1000 * TimerDiff($t)) / 1000 & @CRLF & @CRLF) ;### Debug Console






_DeleteBitmap32($DC_bitmap, $ptr, $hbmp)



Func _CreateNewBmp32($iwidth, $iheight, ByRef $ptr, ByRef $hbmp) ;erstellt leere 32-bit-Bitmap; Rückgabe $HDC und $ptr und handle auf die Bitmapdaten
    $hcdc = _WinAPI_CreateCompatibleDC(0)  ;Desktop-Kompatiblen DeviceContext erstellen lassen
    $tBMI = DllStructCreate($tagBITMAPINFO) ;Struktur der Bitmapinfo erstellen und Daten eintragen
    DllStructSetData($tBMI, 1, DllStructGetSize($tBMI) - 4) ;Structgröße abzüglich der Daten für die Palette
    DllStructSetData($tBMI, 2, $iwidth)
    DllStructSetData($tBMI, 3, -$iheight)  ;minus =standard = bottomup
    DllStructSetData($tBMI, 4, 1)
    DllStructSetData($tBMI, 5, 32)         ;32 Bit = 4 Bytes => AABBGGRR
    $adib = DllCall('gdi32.dll', 'ptr', 'CreateDIBSection', 'hwnd', 0, 'ptr', DllStructGetPtr($tBMI), 'uint', 0, 'ptr*', 0, 'ptr', 0, 'uint', 0)
    $hbmp = $adib[0]                       ;hbitmap handle auf die Bitmap, auch per GDI+ zu verwenden
    $ptr = $adib[4]                        ;pointer auf den Anfang der Bitmapdaten, vom Assembler verwendet
    _WinAPI_SelectObject($hcdc, $hbmp)     ;objekt hbitmap in DC
    Return $hcdc                           ;DC der Bitmap zurückgeben
EndFunc                                    ;==>_CreateNewBmp32

Func _DeleteBitmap32($DC, $ptr, $hbmp)
    _WinAPI_DeleteDC($DC)
    _WinAPI_DeleteObject($hbmp)
    $ptr = 0
EndFunc                                    ;==>_DeleteBitmap32



























