#AutoIt3Wrapper_UseX64=n

;~ #include <assembleit2_64.au3>


Local $maximum = 50000000        ;1299709

$t = TimerInit()
$primzahlen = _PrimeAsm($maximum) ;Assembler aufrufen, code assemblieren, in den Speicher schreiben und ausführen
$m = TimerDiff($t)


StringReplace($primzahlen, @CR, @CR, 0, 1) ;alle CR im String zählen.....auch AutoIt hat SPEEEEED^^
$anzahlprim = @extended  ;hätte man auch vom Assembler zurückgeben lassen können^^

MsgBox(262144, "Primzahlen bis " & $maximum, $anzahlprim & " Primzahlen in " & Int($m) & " Millisekunden, Ausgabe der Zahlen folgt in Console....")
;~ ConsoleWrite($primzahlen & @CRLF)


FileDelete("Primzahlen_asm.dat")
FileWrite("Primzahlen_asm.dat", $primzahlen)
ShellExecute("Primzahlen_asm.dat")



Exit




Func _PrimeAsm($limit)   ;code by Andy@AutoIt.de

    Local $tStruct = DllStructCreate("uint Limit;uint Limes;char Mem[" & $limit + 10 & "]") ;char, dann kann man nachher schön mit den stringfunktionen suchen
    DllStructSetData($tStruct, "Mem", "001") ;die ersten 3 Zahlen setzen, 0=0 1=0 2=1 , 2 ist die erste Primzahl")
    DllStructSetData($tStruct, "Limit", $limit) ;limit in die Struct schreiben
    DllStructSetData($tStruct, "Limes", Floor(Sqrt($limit)) + 1) ;wurzel aus limit in die struct schreiben


    Local $asm_code = "0x558B6C24088B5D00B803000000C74405083130313083C00439D876F18D7D0889FE8B4D00BB0300000089D8F7E0C604063001D839C87EF683C30239CB7736803C1E3175F3535189D8BB0A00000031C931D2F7F3665280C10109C075F366580C30AAE2F9C6070D83C701595B3B5D047CB939CB7CC3C607005DC3"
;~     $asm_code = _AssembleIt2("retbinary", "_primzahlen", "ptr", DllStructGetPtr($tStruct)) ; Assembler aufrufen, um code für dllcalladdress zu bekommen
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $asm_code = ' & $asm_code & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

    Local $asm_struct = DllStructCreate("byte[" & StringLen($asm_code) / 2 - 1 & "]") ;speicher für asm-code bereitstellen...
    DllStructSetData($asm_struct, 1, $asm_code) ;...und mit code beschreiben

    DllCallAddress("none:cdecl", DllStructGetPtr($asm_struct), "ptr", DllStructGetPtr($tStruct)) ;asm-code aufrufen

;~     $Ret = _AssembleIt2("uint", "_primzahlen", "ptr", DllStructGetPtr($tStruct)) ; Assembler aufrufen, wenn man das dllcalladdress-gedöns garnicht braucht
;~     ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $Ret = ' & $Ret & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console
    $pstring = "2" & @CR & "3" & @CR ;2 und 3 sind die ersten Primzahlen
    $pstring &= DllStructGetData($tStruct, "Mem") ;alle Primzahlen aus der struct in den string schreiben

    Return $pstring      ;und zurückgeben

EndFunc                  ;==>_PrimeAsm


#cs _primzahlen

    use32

    push ebp             ; ebp des aufrufenden Programms retten
    mov ebp, dword[ESP+08h]  ; "unseren" ebp setzen auf den Anfang unserer Struct
    ;dann ist...
    ;    [EBP+0h]  der erste Parameter (Limit) , da UINT ist er 4 Bytes lang, daher ist der nächste Parameter bei...
    ;    [EBP+04h] der 2 Parameter (Limes), auch 4 Byte lang...daher findet man den 3. Parameter, unsere struct bei...
    ;    [EBP+08h] der Anfang des Speicherbereichs Mem
    ;ich verwende die Hex-Zahlen, um bei verschiedenen Assemblern einen Standard zu haben, der Windowstaschenrechner ist Gold wert^^

    mov ebx,dword[ebp+0h]  ; Limit
    mov eax,3            ; 3 ist die nächste Primzahl


    Fill:                ; Schleifenanfang
    mov dword[ebp+08h+eax],30313031h    ; an die Speicherstelle in der Struct den String "1010"
    add eax,4            ; eax=eax+4        ;geht auch mit einem rep stosw^^                10
    cmp eax,ebx          ; vergleiche eax mit $limit
    jbe Fill             ; Jump if below or equal (wenn <=) nach Fill, ansonsten weiter
    ;in der struct steht nun 001101010101010101010.....alle vielfachen von 2 sind 0, die erste 0 ist die 0, 2 ist die erste Primzahl!

    ;startadresse Struct Prim holen
    ;~     mov edi, ebp                  ; an ebp steht der erste Parameter, wir brauchen aber die Adresse von ebp+8
    ;~     add edi, 8                    ; ebp+8 ist die adresse des ersten bytes der struct Mem
    lea edi,[ebp+8]
    mov esi, edi         ; ESI=anfang Mem
    mov ecx,dword[EBP+0h]  ; do until limit
    mov ebx,3            ; ebx=aktuelle Zahl in der struct struct[1]=speicher[0] !!!!!!
    L0:
    mov eax,ebx          ; eax=ebx=aktuelle primzahl
    mul eax              ;nächstes vielfaches der prim = quadrat der primzahl
    ;****************************************
    ;ACHTUNG, das Erbebnis von mul ist EDX:EAX also wird auch das edx-register verändert!
    ;*****************************************
    L1:
    mov byte[esi+eax],30h  ;jedes vielfache der Primzahl in der struct zu "0" machen
    add eax,ebx          ;eax=eax+ebx vielfaches der Primzahl        20
    cmp eax,ecx          ; Vielfaches mit limit vergleichen
    jle L1               ; solange eax < limit, die Vielfachen löschen
    L2:                  ;nächste Primzahl holen
    add ebx,2            ;2 zahlen weiter springen ,3,5,7,9,11,13,15....
    cmp ebx,ecx          ;dword[EBP+0h]           ; vgl aktuelle position mit dem Ende von Mem
    ja exit              ;wenn Ende erreicht, exit
    cmp byte[esi+ebx],31h  ;ist an dieser stelle in der struct eine primzahl?
    jne L2               ;wenn nicht, nächste zahl wählen
    ;************************************************************
    ;aus einer Zahl(Registerinhalt) einen ZiffernString machen: http://dcla.rkhb.de/umwandlung/int2dez.html
    ;und in die Primstruct schreiben
    ;wird dieser Bereich auskommentiert, wird ein String aus nullen und einsen zurückgegeben 0=keine Prim 1=Prim
    ;dann können mit den AutoIt-Stringbefehlen die Primzahlen und deren Anzahl ausgelesen werden
    push   ebx           ;alle benötigten Register sichern
    push   ecx           ;alle benötigten Register sichern
    mov eax, ebx         ;Zahl laden
    mov ebx, 10          ; Divisor
    xor ecx, ecx         ;ECX=0 (Anzahl der Ziffern)
    Schleife_1:
    xor edx, edx
    div ebx              ; EDX:EAX / EBX = EAX Rest EDX
    push dx              ; LIFO
    add cl,1             ; ADD soll schneller sein als INC
    or  eax, eax         ; AX = 0?
    jnz Schleife_1       ; nein: nochmal
    Schleife_2:
    pop ax               ; gepushte Ziffern zurückholen
    or al, 00110000b     ; Umwandlung in ASCII
    stosb                ; Nur AL nach [EDI] (EDI ist ein Zeiger auf den String)
    loop Schleife_2      ; bis keine Ziffern mehr da sind
    mov byte [edi],0Dh   ;CR  CarriageReturn, man könnte auch ein Komma (ascii=2C) einsetzen, dazu noch ein nullbyte als EndOfString
    add edi,1            ;ein Byte weiter
    pop   ecx            ;Register wiederherstellen
    pop   ebx            ;Register wiederherstellen
    ;************************************************************Ende Ziffer aus Register

    cmp ebx,dword[EBP+04h] ; vgl aktuelle position mit der wurzel der listengrösse
    jl L0                ; solange ebx < wurzel listengrösse, gehe vielfache eliminieren

    ;jetzt ist die Mem-Struct völlig gefüllt aber die Primzahlen sind nur bis Limes in der Prim-Struct!
    ;also muss der Rest auch noch eingetragen werden
    cmp ebx,ecx          ;dword[EBP+0h]           ; vgl aktuelle position mit dem Ende von Mem
    jl L2                ; solange ebx < limit, gehe vielfache eliminieren bzw "1"en in zifferfolgen umwandeln

    exit:                ;
    mov byte [edi],00h   ;nullbyte als EndOfString anfügen, damit hinter den Zahlen nicht die übrigen 0en und 1en stehen
    pop ebp              ; ebp des aufrufenden Programms restaurieren

    ret                  ; und zurück, in eax steht das Ergebnis

#ce















