#include <GDIPlus.au3>
#include <WindowsConstants.au3>

Opt("MustDeclareVars", 1)
Opt("GUIOnEventMode", 1)

Global Const $iWidth = 1000
Global Const $iHeight = 500

Global $hGUI = GUICreate("GDI+ Rotating Text", $iWidth, $iHeight)

If @OSBuild < 6000 Then WinSetTrans($hGUI, "", 0xFF) ;workaround for XP machines when alpha blending is activated on _GDIPlus_GraphicsClear() function to avoid slow drawing

_GDIPlus_Startup()
Global Const $hDC = _WinAPI_GetDC($hGUI)
Global Const $hHBitmap = _WinAPI_CreateCompatibleBitmap($hDC, $iWidth, $iHeight)
Global Const $hDC_backbuffer = _WinAPI_CreateCompatibleDC($hDC)
Global Const $DC_obj = _WinAPI_SelectObject($hDC_backbuffer, $hHBitmap)
Global Const $hGraphic = _GDIPlus_GraphicsCreateFromHDC($hDC_backbuffer)
_GDIPlus_GraphicsSetCompositingMode($hGraphic, 0)
_GDIPlus_GraphicsSetCompositingQuality($hGraphic, 2)
_GDIPlus_GraphicsSetPixelOffsetMode($hGraphic, 4)

Global Const $iPen_Size = 2, $hPen = _GDIPlus_PenCreate(0, $iPen_Size)
_GDIPlus_PenSetLineJoin($hPen, 2)

Global Const $hBrush = _GDIPlus_BrushCreateSolid(0xFF000000)

Global Const $iFontSize = 190, $sText = "Loading"
Global Const $hFamily = _GDIPlus_FontFamilyCreate("Impact")
Global Const $hFormat = _GDIPlus_StringFormatCreate()
Global Const $hFont = _GDIPlus_FontCreate($hFamily, $iFontSize, 0)
Global $tLayout = _GDIPlus_RectFCreate(0, 0, $iWidth, $iHeight)
_GDIPlus_StringFormatSetAlign($hFormat, 1)
_GDIPlus_StringFormatSetLineAlign($hFormat, 1)

Global Const $hPath = _GDIPlus_PathCreate()
_GDIPlus_PathAddString($hPath, $sText, $tLayout, $hFamily, 0, $iFontSize, $hFormat)

Global $aDim = _GDIPlus_PathGetWorldBounds($hPath)
Global Const $hIter = _GDIPlus_PathIterCreate($hPath)
Global $iPnt, $iCnt = 0, $aPath, $aTmp[0], $iAdd = 30, $iAdd2 = $iAdd / 2
$aPath = $aTmp
While 1
	$iCnt += 1
	If $iCnt >= UBound($aPath) Then ReDim $aPath[$iCnt + 1]
	$aPath[$iCnt] = _GDIPlus_PathCreate()
	$iPnt = _GDIPlus_PathIterNextMarkerPath($hIter, $aPath[$iCnt])
	If $iPnt <= 0 Then ExitLoop
	_GDIPlus_PathFlatten($aPath[$iCnt], 0.1)
WEnd
$aPath[0] = $iCnt

_GDIPlus_PathIterDispose($hIter)

Global Const $fPi = ACos(-1), $fRad2Deg = 180 / $fPi, $iAmountCorners = 4, $iPerspCorrection = 2200, $fSize = 550
Global $fRotSpeed, $start_x, $start_y
Global $aCoordinates[$iAmountCorners][3] = 	[ _;	X			Y			Z
												[	-$fSize, 	-$fSize, 		0], _ ;2
												[ 	$fSize, 	-$fSize, 		0], _ ;3
												[	-$fSize, 	$fSize, 		0], _ ;0
												[ 	$fSize, 	$fSize, 		0]] _ ;1

;	0		1
;
;
;	2		3

Global Const $binarycode = "0x8B7C24048B4C24088B5C240C8B7424100F315089D8F7E1C1E00289C2660F6EEA660F6EF7660FEFFF660F7EEA660F7EF7660F1247FC89CBC1E30290909090909089F829D8660F124F04660F1210660F121C8F660F60C7660F60CF660F60D7660F60DF660FDDC1660FDDC2660FDDC3660F71D002660F67C7660F130783C70883EA080F89B9FFFFFF83EE0175980F775B0F3129D8C3"
Global $tCodeBuffer = DllStructCreate("byte[" & StringLen($binarycode) / 2 - 1 & "]") ;reserve Memory for opcodes
DllStructSetData($tCodeBuffer, 1, $binarycode)
Global Const $ptr_codebuffer = DllStructGetPtr($tCodeBuffer)

GUISetState()

GUISetOnEvent(-3, "Close")

Draw_Chars(0, 1, 2, 3)

Do

	Draw_Chars(0, 1, 2, 3)


Until Not Sleep(10)

Func Draw_Chars($p1, $p2, $p3, $p4)
#Region calculate positionn
	Local $x1, $y1, $x2, $y2, $x3, $y3, $x4, $y4, $z1, $z2, $z3
	$x1 = $aCoordinates[$p1][0] * (1 + $aCoordinates[$p1][2] / $iPerspCorrection)
	$y1 = $aCoordinates[$p1][1] * (1 + $aCoordinates[$p1][2] / $iPerspCorrection)
	$z1 = $aCoordinates[$p1][2]
	$x2 = $aCoordinates[$p2][0] * (1 + $aCoordinates[$p2][2] / $iPerspCorrection)
	$y2 = $aCoordinates[$p2][1] * (1 + $aCoordinates[$p2][2] / $iPerspCorrection)
	$z2 = $aCoordinates[$p2][2]
	$x3 = $aCoordinates[$p3][0] * (1 + $aCoordinates[$p3][2] / $iPerspCorrection)
	$y3 = $aCoordinates[$p3][1] * (1 + $aCoordinates[$p3][2] / $iPerspCorrection)
	$z3 = $aCoordinates[$p3][2]
	$x4 = $aCoordinates[$p4][0] * (1 + $aCoordinates[$p4][2] / $iPerspCorrection)
	$y4 = $aCoordinates[$p4][1] * (1 + $aCoordinates[$p4][2] / $iPerspCorrection)

	Local $aPoints[5][2], $fDeg
	$aPoints[0][0] = 4
	$aPoints[1][0] = $start_x + $x1
	$aPoints[1][1] = $start_y + $y1
	$aPoints[2][0] = $start_x + $x2
	$aPoints[2][1] = $start_y + $y2
	$aPoints[3][0] = $start_x + $x3
	$aPoints[3][1] = $start_y + $y3
	$aPoints[4][0] = $start_x + $x4
	$aPoints[4][1] = $start_y + $y4
#EndRegion

	_GDIPlus_GraphicsClear($hGraphic, 0xFFFFFFFF)
	Local $i, $hPath_Clone, $aPos, $hMatrix, $hBmp, $hBmp_Blur, $hCtxt, $iColor, $iAlpha, $iAlpha2, $fBlur
	Local $iStride, $tBitmapData, $ptr_bitmap, $iW, $iH, $blur_count = 10
	For $i = 1 To $aPath[0]
		$hPath_Clone = _GDIPlus_PathClone($aPath[$i])
		_GDIPlus_PathWarp($hPath_Clone, Null, $aPoints, 0, 0, $iWidth, $iHeight)

		$aPos = _GDIPlus_PathGetWorldBounds($hPath_Clone)

		$iW = Int($aPos[2] + $iAdd)
		$iH = Int($aPos[3] + $iAdd)

		$iStride = 4 * $iW
		$tBitmapData = _DllStructCreateAlign16("dword pixel[" & $iStride * $iH + 2 * $iStride * $blur_count & "]")
		$ptr_bitmap = DllStructGetPtr($tBitmapData) + $iStride * $blur_count

		$hBmp = _GDIPlus_BitmapCreateFromScan0($iW, $iH, $GDIP_PXF32ARGB, $iStride, $ptr_bitmap)
		$hCtxt = _GDIPlus_ImageGetGraphicsContext($hBmp)

		_GDIPlus_GraphicsSetSmoothingMode($hCtxt, 4)
		_GDIPlus_GraphicsSetPixelOffsetMode($hCtxt, 4)
		_GDIPlus_GraphicsSetCompositingMode($hCtxt, 0)
		_GDIPlus_GraphicsSetCompositingQuality($hCtxt, 2)

		$hMatrix = _GDIPlus_MatrixCreate()
		_GDIPlus_MatrixTranslate($hMatrix, -$aPos[0] + $iAdd2, -$aPos[1] + $iAdd2)
		_GDIPlus_PathTransform($hPath_Clone, $hMatrix)

		Switch $z1
			Case $z1 < 0
				$iColor = Int(Abs($z1) / ($i + 1))
				$fBlur = Int(($aPath[0] - $i) / 2) - 1
			Case Else
				$iColor = Int(Abs($z1) / ($aPath[0] - $i + 1))
				$fBlur = Int($i / 2) - 1
		EndSwitch
		$iColor = $iColor > 0xFF ? 0xFF : $iColor < 0 ? 0 : $iColor
		$iAlpha = 0xFF - Int($iColor / 1.5)
		$iAlpha2 = 0xFF - Int($iColor / 1.25)

		_GDIPlus_BrushSetSolidColor($hBrush, BitOR($iAlpha * 0x1000000, 0))
		_GDIPlus_PenSetColor($hPen, BitOR($iAlpha2 * 0x1000000,  0))

		_GDIPlus_GraphicsDrawPath($hCtxt, $hPath_Clone, $hPen)

		_GDIPlus_GraphicsFillPath($hCtxt, $hPath_Clone, $hBrush)


;~  		$hBmp_Blur = _Blur($hBmp, $aPos[2], $aPos[3], $fBlur)
;~ 		_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBmp_Blur, $aPos[0] - $iAdd2, $aPos[1] - $iAdd2, $aPos[2], $aPos[3])

		If $fBlur > 0 Then DllCallAddress("uint:cdecl", $ptr_codebuffer, "ptr", $ptr_bitmap, "uint", $iW, "uint", $iH, "uint", $fBlur)

;~ 	    Local $hEffect = _GDIPlus_EffectCreateBlur($fBlur)
;~ 		_GDIPlus_BitmapApplyEffect($hBmp, $hEffect)

		_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBmp, $aPos[0] - $iAdd2 + $iWidth / 2, $aPos[1] - $iAdd2 + $iHeight / 2, $iW, $iH)
;~ 		$ptr_bitmap = 0
;~ 		$tBitmapData = 0
;~ 		_GDIPlus_EffectDispose($hEffect)

		_GDIPlus_MatrixDispose($hMatrix)
		_GDIPlus_PathDispose($hPath_Clone)
		_GDIPlus_GraphicsDispose($hCtxt)
		_GDIPlus_BitmapDispose($hBmp)
		_GDIPlus_BitmapDispose($hBmp_Blur)
	Next
	_WinAPI_BitBlt($hDC, 0, 0, $iWidth, $iHeight, $hDC_backbuffer, 0, 0, $SRCCOPY)

#Region rotate points
	Local $i, $x, $y
	Local Static $f = 0
	$fRotSpeed = -0.0333 * Cos($f / 290)
	$f += 10
	For $i = 0 To $iAmountCorners - 1 ;calculate y-axis rotation only
		$x = $aCoordinates[$i][0] * Cos($fRotSpeed) + $aCoordinates[$i][2] * Sin($fRotSpeed)
		$y = -$aCoordinates[$i][0] * Sin($fRotSpeed) + $aCoordinates[$i][2] * Cos($fRotSpeed)
		$aCoordinates[$i][0] = $x
		$aCoordinates[$i][2] = $y
	Next
#EndRegion
EndFunc   ;==>Draw_Chars

Func _Blur($hBitmap, $iW, $iH, $fScale = 0.175, $iQual = 2); by eukalyptus
	$fScale = $fScale > 1.0 ? 1.0 : $fScale < 0.1 ? 0.1 : $fScale
	Local $hBmpSmall = _GDIPlus_BitmapCreateFromScan0($iW, $iH)
	Local $hGfxSmall = _GDIPlus_ImageGetGraphicsContext($hBmpSmall)
	_GDIPlus_GraphicsSetPixelOffsetMode($hGfxSmall, 4)
	_GDIPlus_GraphicsSetCompositingMode($hGfxSmall, 0)
	_GDIPlus_GraphicsSetCompositingQuality($hGfxSmall, 2)

	Local $hBmpBig = _GDIPlus_BitmapCreateFromScan0($iW, $iH)
	Local $hGfxBig = _GDIPlus_ImageGetGraphicsContext($hBmpBig)
	_GDIPlus_GraphicsSetPixelOffsetMode($hGfxBig, 4)
	_GDIPlus_GraphicsSetCompositingMode($hGfxBig, 0)
	_GDIPlus_GraphicsSetCompositingQuality($hGfxBig, 2)

	_GDIPlus_GraphicsScaleTransform($hGfxSmall, $fScale, $fScale)
	_GDIPlus_GraphicsSetInterpolationMode($hGfxSmall, $iQual)

	_GDIPlus_GraphicsScaleTransform($hGfxBig, 1 / $fScale, 1 / $fScale)
	_GDIPlus_GraphicsSetInterpolationMode($hGfxBig, $iQual)

	_GDIPlus_GraphicsDrawImageRect($hGfxSmall, $hBitmap, 0, 0, $iW, $iH)
	_GDIPlus_GraphicsDrawImageRect($hGfxBig, $hBmpSmall, 0, 0, $iW, $iH)

	_GDIPlus_BitmapDispose($hBmpSmall)
	_GDIPlus_GraphicsDispose($hGfxSmall)
	_GDIPlus_GraphicsDispose($hGfxBig)
	Return $hBmpBig
EndFunc   ;==>_Blur

Func _DllStructCreateAlign16($tStruct, $pPointer = "") ;align auf 16-byte adresse
	Local $tTemp = DllStructCreate($tStruct)
	Local Const $iAlign16 = Mod(DllStructGetSize($tTemp), 16)
	$tTemp = 0
	Switch $iAlign16
		Case 0
			If $pPointer <> "" Then Return DllStructCreate($tStruct, $pPointer)
			Return DllStructCreate($tStruct)
		Case Else
			If $pPointer <> "" Then DllStructCreate("align " & $iAlign16 & ";" & $tStruct, $pPointer)
			Return DllStructCreate("align " & $iAlign16 & ";" & $tStruct)
	EndSwitch
EndFunc   ;==>_DllStructCreateAlign16

Func Close()
	Local $i
	For $i = 1 To $aPath[0]
		_GDIPlus_PathDispose($aPath[$i])
	Next
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_PathDispose($hPath)
	_GDIPlus_BrushDispose($hBrush)
	_GDIPlus_PenDispose($hPen)
	_GDIPlus_GraphicsDispose($hGraphic)
	_WinAPI_SelectObject($hDC, $DC_obj)
	_WinAPI_DeleteObject($hHBitmap)
	_WinAPI_DeleteObject($hBrush)
	_WinAPI_ReleaseDC($hGUI, $hDC)
	_GDIPlus_Shutdown()
	GUIDelete()
	Exit
EndFunc   ;==>Close