#AutoIt3Wrapper_UseX64=n                                                                      ;32Bit-Modus
#include-once
#include <assembleit2_64.au3>

#cs simpleexample                                                                             ;using int and float in the same code

    use32
    mov eax, [esp+4]                                                                          ;first variable from stack
    mov ebx, [esp+8]                                                                          ;second variable from stack
    add eax, ebx                                                                              ;add them..
    finit                                                                                     ;init FPU
    fld dword[esp+8]                                                                          ;ST0 = [esp+8]
    fld dword[esp+4]                                                                          ;ST0 = [esp+4]      ST1 = [esp+8]
    fsub st0,st1                                                                              ;ST0 = ST0 – ST1    ST0 = [esp+4] – [esp+8]
;~     _ASMdbg_()
    ret                                                                                       ;...eax/rax is returned or ST0 depending on return type "int" or "float"

#ce simpleexample                                                                             ;using int and float in the same code

$a = 5.3
$b = 3.1

;only assemble code and run it....
$ret = _AssembleIt2("int", "simpleexample", "int", $a, "int", $b)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

$ret = _AssembleIt2("float", "simpleexample", "float", $a, "float", $b)                       ;code is debuggable see debugger example, you can use AutoIt-Variables in the code and more...
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

;or
;force _AssembleIt() to make binary code to use with DllCallAddress()
$binarycode = _AssembleIt2("retbinary", "simpleexample", "int", $a, "int", $b)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $binarycode = ' & $binarycode & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


;or
;force _AssembleIt() to make AutoIt code using DllCallAddress() and copy this code into the clipboard
$ret = _AssembleIt2("int", "simpleexample", "int", $a, "int", $b, "retbinary", @ScriptLineNumber)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


;~ ;use the binary code with DllCallAddress(), no assembleit2_64.au3 or any other function is necessary, following code can be standalone in any AutoIt-Script
Global $tCodeBuffer = DllStructCreate("byte[24]") ;reserve Memory for opcodes
DllStructSetData($tCodeBuffer, 1,"0x8B4424048B5C240801D89BDBE3D9442408D9442404D8E1C3") ;write opcodes into memory
$ret=DllCallAddress("int:cdecl", DllStructGetPtr($tCodeBuffer), "int", $a, "int", $b)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret[0] & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

$ret = DllCallAddress("float:cdecl", DllStructGetPtr($tCodeBuffer), "float", $a, "float", $b)       ;DllCallAddress returns an array!!
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret[0] & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console






