;simple example how to use _AssembleIt2() in x64 mode
;remember that the code is NOT debuggable atm and needs the help of the AssembleIt2_Helper64.EXE file (which will be created and started if not in the actual directory)
;if the binary code called by DllCallAddress() there is no need of the AssembleIt2_Helper64.EXE file

#AutoIt3Wrapper_UseX64=y                                                   ;64Bit-Modus

#include-once
#include <assembleit2_64.au3>

#cs simpleexample
    use64
    push rdi										;save volatile registers , remember https://learn.microsoft.com/en-us/cpp/build/x64-calling-convention?view=msvc-17
    push rsi
    push rbx
    push rbp
    mov rax, rcx                                    ;first variable from rxc
    mov rbx, rdx                                    ;second variable from rdx
    add rax, rbx                                    ;add them..
    pop rbp                                         ;pop saved volatile registers
    pop rbx
    pop rsi
    pop rdi
    ret                                             ;...eax/rax is returned
#ce simpleexample

$a = 5
$b = 3
;run assembler and assembled code
$ret = _AssembleIt2("uint64", "simpleexample", "uint64", $a, "uint64", $b) ;code is NOT debuggable in x64!!!
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

;or
;force _AssembleIt() to make binary code to use with DllCallAddress()
$binarycode = _AssembleIt2("retbinary", "simpleexample")                   ;returns assembly-code
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $binarycode = ' & $binarycode & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

;or
;force _AssembleIt() to make AutoIt code using DllCallAddress() and copy this code into the clipboard
$ret = _AssembleIt2("uint64", "simpleexample", "uint64", $a, "uint64", $b, "retbinary", @ScriptLineNumber)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


;remember to close the process of the AssembleIt2_Helper64.EXE at the end of your script
Processclose($AssembleIt2_Helper64pid)


;use the binary code with DllCallAddress(), no assembleit2_64.au3 or any other function is necessary, following code can be standalone in any AutoIt-Script

;the following code of the function SIMPLEEXAMPLE is returned by AssebleIt2_64 and pasted from clipboard!
Local $aStructMem = DllCall("kernel32.dll", "ptr", "VirtualAlloc", "ptr", 0, "ulong_ptr", DllStructGetSize(DllStructCreate("byte[18]")), "dword", 4096, "dword", 64)
Local $tCodeBuffer = DllStructCreate("byte[18]", Number($aStructMem[0]))  ;Address aligned 64 and Memory is  $MEM_COMMIT, $PAGE_EXECUTE_READWRITE
DllStructSetData($tCodeBuffer, 1,"0x575653554889C84889D34801D85D5B5E5FC3") ;write opcodes into memory
$ret=DllCallAddress("uint64:cdecl", DllStructGetPtr($tCodeBuffer), "uint64", $a, "uint64", $b)

ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $ret = ' & $ret[0] & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


